#include "soapH.h"
#include "soapsoapTemperatureServiceProxy.h"
#include "soapTemperatureService.nsmap"
#include <cstdlib>
#include <iostream>

int main(int argc, char **argv) {
	if (argc != 2) {
		std::cerr << "*** You must supply a zip code" << std::endl;
		std::exit(2);
	}
	const xsd__string zipcode = argv[1];

	soapTemperatureService ts;    // construct the Temp Service SOAP object
	ts.soap->connect_timeout = 2; // in seconds
	tns__getTempResponse r;

	if (ts.getTemp(zipcode, &r) != SOAP_OK) {
		soap_print_fault(ts.soap, stderr);  
		std::exit(2);
	} else {
		const xsd__float temperature = r._return_;
		std::cout << "The temperature at zip code " << zipcode
		    << " is " << temperature << " degrees F." << std::endl;
	}
}
