#include "soapH.h"
#include "soapsoapGoogleSearchServiceProxy.h"
#include "soapGoogleSearchService.nsmap"
#include <cstdlib>
#include <iostream>

using std::cout; using std::endl;

int main(int argc, char **argv) {
	if (argc != 2) {
		std::cerr << "*** You must supply a search string" << std::endl;
		std::exit(2);
	}

	soapGoogleSearchService gs;  // construct the Google Service SOAP object
	gs.soap->connect_timeout = 2; // in seconds

        xsd__string key = "0qKsw/ZQFHK0cNnqig/54CMsdovgsdTj";
        xsd__string q = argv[1];
        int start = 0;
        int maxResults = 10;
        bool filter = false;
        xsd__string restrict_ = "";
        bool safeSearch = true;
        xsd__string lr = "";
        xsd__string ie = "";
        xsd__string oe = "";

	typens__doGoogleSearchResponse r;

	if (gs.doGoogleSearch(key, q, start, maxResults, filter, restrict_, 
				safeSearch, lr, ie, oe, &r) != SOAP_OK) {
		soap_print_fault(gs.soap, stderr);  
		std::exit(2);
	} else {
		typens__GoogleSearchResult* res = r._return_;
		cout << "The search for \"" << res->searchQuery
		     << "\" produced " << res->estimatedTotalResultsCount
		     << " hits, here are at most " << maxResults << ":" << endl;
		cout << endl;
		ResultElementArray* rea = res->resultElements;
		for (int j = 0; j < rea->__size; j++) {
			typens__ResultElement* re = &rea->__ptr[j];
                	cout << "************************" << endl;
                	cout << "URL is: " << re->URL << endl;
                	cout << "Title is: " << re->title << endl;
                	cout << "Snippet is: " << re->snippet << endl;
		}
	}
}
