// Axis/JAX-RPC version

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import javax.xml.namespace.QName;

public class TempClient { 
   public static void main(String[] args) throws Exception { 
       if (args.length != 1) {
           System.err.println("*** You must supply a zip code");
	   System.exit(1);
       }
       String zip = args[0];
       String endpt = "http://services.xmethods.net:80/soap/servlet/rpcrouter";
       java.net.URL url = new java.net.URL(endpt);
       String urn = "urn:xmethods-Temperature";
       Service service = new Service();
       Call call = (Call) service.createCall();
       call.setTargetEndpointAddress(url);
       call.setOperationName(new QName(urn, "getTemp"));
/*
       call.addParameter("zipcode",
                         org.apache.axis.Constants.XSD_STRING,
                         javax.xml.rpc.ParameterMode.IN);
       call.setReturnType(org.apache.axis.Constants.XSD_FLOAT);
*/
       try { 
           //System.out.println("invoke service\n" + "  URL= " + url + "\n  URN= " + urn); 
           Float result = (Float) call.invoke( new Object[] { zip } );
           System.out.println("Current temperature at zip code " 
				+ zip + " is " + result + " degrees"); 
       }
       catch (Exception e) {
           System.err.println("Exception! " + e.toString());
       }
   } 
} 
